// vercertDlg.cpp : implementation file
//

#include "stdafx.h"
#include "vercert.h"
#include "vercertDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CvercertDlg dialog




CvercertDlg::CvercertDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CvercertDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CvercertDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CvercertDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CvercertDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CvercertDlg message handlers

BOOL CvercertDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CvercertDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CvercertDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CvercertDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



#include <winhttp.h>
#include <shlwapi.h>
HINTERNET hRequest = 0; // Handle usato dalle winhttp per inviare/ricevere dati
#define ASP_SLEEP_TIME 20
#define ASP_START_TIMEOUT 60000 // un minuto di attesa per far inizializzare il processo host ASP
#define ASP_CONNECT_TIMEOUT 10000 // timeout prima di determinare che il server non e' raggiungibile
HINTERNET hSession = 0, hConnect = 0;


void ASP_WinHTTPSetup(char *server_ip)
{
	WINHTTP_CURRENT_USER_IE_PROXY_CONFIG ProxyConfig;
	WINHTTP_PROXY_INFO ProxyInfo;
	WINHTTP_AUTOPROXY_OPTIONS OptPAC;
	DWORD dwOptions = 0;
	BOOL isProxy = FALSE;
	wchar_t  _wHost[128]; 
	wchar_t  _wHostProto[128]; 	
	char *types[] = { "*\x0/\x0*\x0",0 };

	// Inidirizzo ip del server in wide char
	// per utilizzarlo nelle funzioni direttamente
	swprintf(_wHost, L"%S", server_ip);
	swprintf(_wHostProto, L"https://%S", server_ip);

	// Crea una sessione per winhttp.
	// L'eventuale proxy verra' settato in seguito
    if ( !(hSession = WinHttpOpen( L"Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)",  
                                   WINHTTP_ACCESS_TYPE_NO_PROXY, 0, WINHTTP_NO_PROXY_BYPASS, 0)) )
		return;

	// winhttp fornira' le credenziali dell'utente 
	// per ogni richiesta di autenticazione
	dwOptions = WINHTTP_AUTOLOGON_SECURITY_LEVEL_LOW;
	WinHttpSetOption(hSession, WINHTTP_OPTION_AUTOLOGON_POLICY, &dwOptions, sizeof(DWORD));

	// Cerca nel registry le configurazioni del proxy
	if (WinHttpGetIEProxyConfigForCurrentUser(&ProxyConfig)) {
		// I metodi di configurazione sono nell'ordine inverso
		// rispetto a come li considera internet explorer
		// In questo modo l'ultimo che riesce a trovare un proxy 
		// verra' utilizzato.
		if (ProxyConfig.lpszProxy) {
			// Proxy specificato
			ProxyInfo.lpszProxy = ProxyConfig.lpszProxy;
			ProxyInfo.dwAccessType = WINHTTP_ACCESS_TYPE_NAMED_PROXY;
			ProxyInfo.lpszProxyBypass = NULL;
			isProxy = TRUE;
		}

		if (ProxyConfig.lpszAutoConfigUrl) {
			// Script proxy pac
			OptPAC.dwFlags = WINHTTP_AUTOPROXY_CONFIG_URL;
			OptPAC.lpszAutoConfigUrl = ProxyConfig.lpszAutoConfigUrl;
			OptPAC.dwAutoDetectFlags = 0;
			OptPAC.fAutoLogonIfChallenged = TRUE;
			OptPAC.lpvReserved = 0;
			OptPAC.dwReserved = 0;

			if (WinHttpGetProxyForUrl(hSession ,_wHostProto, &OptPAC, &ProxyInfo))
				isProxy = TRUE;
		}

		if (ProxyConfig.fAutoDetect) {
			// Autodetect proxy
			OptPAC.dwFlags = WINHTTP_AUTOPROXY_AUTO_DETECT;
			OptPAC.dwAutoDetectFlags = WINHTTP_AUTO_DETECT_TYPE_DHCP | WINHTTP_AUTO_DETECT_TYPE_DNS_A;
			OptPAC.fAutoLogonIfChallenged = TRUE;
			OptPAC.lpszAutoConfigUrl = NULL;
			OptPAC.lpvReserved = 0;
			OptPAC.dwReserved = 0;

			if (WinHttpGetProxyForUrl(hSession ,_wHostProto, &OptPAC, &ProxyInfo))
				isProxy = TRUE;
		}
	}

	// Settiamo il proxy se ne abbiamo bisogno
	// XXX Qui da ProxyInfo dovremmo nascondere la connessione al proxy
	// Questa viene vista solo nelle TCP row NON extended (altrimenti nasconde il PID)
	if (isProxy)
		WinHttpSetOption(hSession, WINHTTP_OPTION_PROXY, &ProxyInfo, sizeof(ProxyInfo));

	// Definisce il target
	if ( !(hConnect = WinHttpConnect( hSession, (LPCWSTR) _wHost, INTERNET_DEFAULT_HTTPS_PORT, 0)))
		return;
	// Crea la richiesta
	if ( !(hRequest = WinHttpOpenRequest( hConnect, L"POST", L"/", NULL, WINHTTP_NO_REFERER, (LPCWSTR *) types, WINHTTP_FLAG_SECURE)) )
		return;

	// Visto che utilizziamo SSL, settiamo winhttp per essere meno restrittiva sui certificati
	dwOptions = SECURITY_FLAG_IGNORE_CERT_CN_INVALID | SECURITY_FLAG_IGNORE_CERT_DATE_INVALID | SECURITY_FLAG_IGNORE_UNKNOWN_CA;
	//WinHttpSetOption(hRequest, WINHTTP_OPTION_SECURITY_FLAGS, &dwOptions, sizeof(DWORD));

	// Setta i timeout:
	// resolve = 1 millisecondo (usa indirizzi IP)
	// connect = 10 secondi
	// send e receive = infinito (una volta connesso si aspetta di 
	//                  mandare e ricevere, se il protocollo e' corretto. Altrimenti
	//                  posso usare le ASP_Read/Write non bloccanti o affidarmi ai 
	//				    timeout TCP...spero).
	WinHttpSetTimeouts(hRequest, 1, ASP_CONNECT_TIMEOUT, -1, -1);
}


#define GINO L"Hacking"
#include <Wincrypt.h>
void CvercertDlg::OnBnClickedOk()
{
//	wchar_t  _wheaders[1024];
//	DWORD len = 10;

	ASP_WinHTTPSetup("192.168.1.170");
//	WINHTTP_CERTIFICATE_INFO cert_info;

	CERT_CONTEXT *cert_ctx;
	WinHttpSetTimeouts(hRequest, 1, 2000, -1, -1);

//	BYTE public_key[]={0x30,0x81,0x89,0x02,0x81,0x81,0x00,0xB9,0xF0,0xB8,0xAA,0xEB,0x37,0xE4,0x49,0x2D,0xAE,0x33,0x5B,0xED,0xFB,0x3A,0x8D,0xF0,0xFB,0x62,0xAE,0x86,0x09,0xDA,0xCA,0xEF,0xBC,0xF3,0x7C,0xCC,0xA8,0x09,0x21,0xCB,0x44,0xB0,0x71,0xCB,0xBB,0x7D,0xA1,0x73,0x60,0x6A,0x7F,0xFA,0x70,0x29,0x31,0xE5,0xA1,0xEB,0x19,0xB2,0xB8,0xBC,0xE0,0xD2,0x5E,0x74,0x5C,0xD9,0x11,0x51,0x46,0xF0,0xCD,0x2C,0xE3,0x95,0x25,0xFE,0x42,0x94,0x59,0x3A,0x13,0xFF,0xB1,0x2A,0x16,0x24,0xD4,0xBF,0x8D,0x87,0x69,0xD6,0xB3,0x8A,0x49,0x66,0x2F,0xE4,0x39,0xD0,0xB1,0x98,0x9E,0x0C,0xAB,0x11,0x95,0xFD,0x86,0x37,0x11,0xC9,0x3C,0xAC,0xB0,0xBC,0x6F,0x48,0x5E,0xF9,0x29,0xC8,0x83,0xDE,0x90,0xFD,0xC7,0x7A,0xAD,0x36,0x1D,0xB5,0xD1,0x02,0x03,0x01,0x00,0x01};

//	DWORD num = sizeof(public_key);
	//swprintf(_wheaders, L"%ls %d", L"Content-Length:", 0);
	BOOL ret = WinHttpSendRequest( hRequest, WINHTTP_NO_ADDITIONAL_HEADERS , -1L, WINHTTP_NO_REQUEST_DATA, 0, 0, NULL);

//	DWORD info_size = sizeof(cert_info);
//	ret = WinHttpQueryOption(hRequest, WINHTTP_OPTION_SECURITY_CERTIFICATE_STRUCT, &cert_info, &info_size);

	DWORD info_size = 4;
	ret = WinHttpQueryOption(hRequest, WINHTTP_OPTION_SERVER_CERT_CONTEXT , &cert_ctx, &info_size);
	
	DWORD number = cert_ctx->pCertInfo->SubjectPublicKeyInfo.PublicKey.cbData;
	BYTE *ptr = cert_ctx->pCertInfo->SubjectPublicKeyInfo.PublicKey.pbData;

	FILE *fd;
	fd = fopen("C:\\cert.txt","w");
	for (DWORD i=0; i<number; i++) {
		fprintf(fd, "0x%.2X,", ptr[i]);
	}
	fclose(fd);



	CertFreeCertificateContext(cert_ctx);


/*
	DWORD dwOptions = SECURITY_FLAG_IGNORE_CERT_CN_INVALID | SECURITY_FLAG_IGNORE_CERT_DATE_INVALID | SECURITY_FLAG_IGNORE_UNKNOWN_CA;
	WinHttpSetOption(hRequest, WINHTTP_OPTION_SECURITY_FLAGS, &dwOptions, sizeof(DWORD));
	swprintf(_wheaders, L"%ls %d", L"Content-Length:", len);
	WinHttpAddRequestHeaders( hRequest, _wheaders, -1, WINHTTP_ADDREQ_FLAG_REPLACE);
	ret = WinHttpSendRequest( hRequest, WINHTTP_NO_ADDITIONAL_HEADERS, -1L, WINHTTP_NO_REQUEST_DATA, 0, len, NULL);

	ret = WinHttpWriteData(hRequest, "ABCDEFGHI\0\0", len, &len);

		// Legge la risposta di SYNC
	char dummy_resp[200]; 
	DWORD bytes_read;
	WinHttpReceiveResponse(hRequest, 0);
	WinHttpReadData(hRequest, dummy_resp, 4, &bytes_read);

	swprintf(_wheaders, L"%ls %d", L"Content-Length:", 6);
	WinHttpAddRequestHeaders( hRequest, _wheaders, -1, WINHTTP_ADDREQ_FLAG_REPLACE);
	ret = WinHttpSendRequest( hRequest, WINHTTP_NO_ADDITIONAL_HEADERS, -1L, WINHTTP_NO_REQUEST_DATA, 0, len, NULL);
	ret = WinHttpWriteData(hRequest, "ABCDEFGHI\0\0", 6, &len);
*/
	// TODO: Add your control notification handler code here
	OnOK();
}
